# Class DefaultDerivedCRS

Object
FormattableObject
AbstractIdentifiedObject
AbstractReferenceSystem
AbstractCRS
DefaultDerivedCRS

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `Printable`, `CoordinateReferenceSystem`, `DerivedCRS`, `GeneralDerivedCRS`, `SingleCRS`, `IdentifiedObject`, `ReferenceSystem`

public class DefaultDerivedCRS extends AbstractCRS implements DerivedCRS
A coordinate reference system that is defined by its coordinate conversion from another CRS. A `DerivedCRS` instance may implement one of the interfaces listed below, provided that the conditions in the right column are met (derived from ISO 19162):

Derived CRS types
Type | Conditions
--- | ---
`GeodeticCRS` | Base CRS is also a `GeodeticCRS` and is associated to the same type of coordinate system.
`VerticalCRS` | Base CRS is also a `VerticalCRS` and coordinate system is a `VerticalCS`.
`TemporalCRS` | Base CRS is also a `TemporalCRS` and coordinate system is a `TimeCS`.
`ParametricCRS` | Base CRS is also a `ParametricCRS` and coordinate system is a `ParametricCS`.
`EngineeringCRS` | Base CRS is a `GeodeticCRS`, `ProjectedCRS` or `EngineeringCRS`.

Those specialized subclasses can be inferred automatically by the `create(…)` static method. Alternatively, users can create their own `DefaultDerivedCRS` subclass implementing the desired interface.

## Immutability and thread safety

This base class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. Most SIS subclasses and related classes are immutable under similar conditions. This means that unless otherwise noted in the javadoc, `DerivedCRS` instances created using only SIS factories and static constants can be shared by many objects and passed between threads without synchronization.

Since:
  0.6
See Also:
  - `GeodeticAuthorityFactory​.createDerivedCRS(String)`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, DOMAINS_KEY, LOCALE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  ### Fields inherited from interface ReferenceSystem

  `DOMAIN_OF_VALIDITY_KEY, SCOPE_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `DefaultDerivedCRS(Map<String,?> properties, SingleCRS baseCRS, CoordinateReferenceSystem interpolationCRS, OperationMethod method, MathTransform baseToDerived, CoordinateSystem derivedCS)`
  Creates a derived CRS from a math transform.
  `protected`
  `DefaultDerivedCRS(Map<String,?> properties, SingleCRS baseCRS, Conversion conversion, CoordinateSystem derivedCS)`
  Creates a derived CRS from a defining conversion.
  `protected`
  `DefaultDerivedCRS(DerivedCRS crs)`
  Constructs a new coordinate reference system with the same values as the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultDerivedCRS`
  `castOrCopy(DerivedCRS object)`
  Returns a SIS coordinate reference system implementation with the same values as the given arbitrary implementation.
  `static DefaultDerivedCRS`
  `create(Map<String,?> properties, SingleCRS baseCRS, CoordinateReferenceSystem interpolationCRS, OperationMethod method, MathTransform baseToDerived, CoordinateSystem derivedCS)`
  Creates a derived CRS from a math transform and a type inferred from the given arguments.
  `static DefaultDerivedCRS`
  `create(Map<String,?> properties, SingleCRS baseCRS, Conversion baseToDerived, CoordinateSystem derivedCS)`
  Creates a derived CRS from a defining conversion and a type inferred from the given arguments.
  `boolean`
  `equals(Object object, ComparisonMode mode)`
  Compares this coordinate reference system with the specified object for equality.
  `DefaultDerivedCRS`
  `forConvention(AxesConvention convention)`
  Returns a CRS equivalent to this one but with axes rearranged according the given convention.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats the inner part of the Well Known Text (WKT) representation of this CRS.
  `SingleCRS`
  `getBaseCRS()`
  Returns the CRS on which the conversion is applied.
  `Conversion`
  `getConversionFromBase()`
  Returns the conversion from the base CRS to this CRS.
  `CoordinateSystem`
  `getCoordinateSystem()`
  Returns the coordinate system.
  `Datum`
  `getDatum()`
  Returns the datum of the base CRS.
  `DefaultDatumEnsemble<?>`
  `getDatumEnsemble()`
  Returns the datum ensemble of the base CRS.
  `Class<? extends DerivedCRS>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.

  ### Methods inherited from class AbstractCRS

  `castOrCopy`

  ### Methods inherited from class AbstractReferenceSystem

  `getDomainOfValidity, getScope`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getDomains, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

  ### Methods inherited from interface ReferenceSystem

  `getDomainOfValidity, getScope`

- ## Constructor Details

  - ### DefaultDerivedCRS

    protected DefaultDerivedCRS(Map<String,?> properties, SingleCRS baseCRS, Conversion conversion, CoordinateSystem derivedCS) throws MismatchedDimensionException
    Creates a derived CRS from a defining conversion. The properties given in argument follow the same rules as for the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `Identifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `Identifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "domains" | `DefaultObjectDomain` (optionally as array) | `AbstractIdentifiedObject.getDomains()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`

    The supplied `conversion` argument shall not includes the operation steps for performing unit conversions and change of axis order since those operations will be inferred by this constructor.
    Parameters:
      `properties` - the properties to be given to the new derived CRS object.
      `baseCRS` - coordinate reference system to base the derived CRS on.
      `conversion` - the defining conversion from a normalized base to a normalized derived CRS.
      `derivedCS` - the coordinate system for the derived CRS. The number of axes must match the target dimension of the `baseToDerived` transform.
    Throws:
      `MismatchedDimensionException` - if the source and target dimensions of `baseToDerived` do not match the dimensions of `base` and `derivedCS` respectively.
    See Also:
      - `create(Map, SingleCRS, Conversion, CoordinateSystem)`

  - ### DefaultDerivedCRS

    protected DefaultDerivedCRS(Map<String,?> properties, SingleCRS baseCRS, CoordinateReferenceSystem interpolationCRS, OperationMethod method, MathTransform baseToDerived, CoordinateSystem derivedCS)
    Creates a derived CRS from a math transform. The given `MathTransform` shall transform coordinate values specifically from the `baseCRS` to `this` CRS (optionally with an interpolation CRS); there is no consideration about normalized CRS in this constructor.

    #### Conversion properties

    The `properties` map given in argument can contain any entries documented in the above constructor, together with any entries documented by the conversion constructor provided that the `Conversion` entry keys are prefixed by `"conversion."`. In particular, the two first properties listed below are mandatory:

    Mandatory properties and some optional properties
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `Identifier` or `String` | `this.getName()`
    "conversion.name" | `Identifier` or `String` | `conversionFromBase.getName()`
    Optional properties (non exhaustive list)
    "identifiers" | `Identifier` (optionally as array) | `this.getIdentifiers()`
    "domainOfValidity" | `Extent` | `domain.getDomainOfValidity()`

    Parameters:
      `properties` - the properties to be given to the `DefaultConversion` object (with keys prefixed by `"conversion."`) and to the new derived CRS object.
      `baseCRS` - coordinate reference system to base the derived CRS on.
      `interpolationCRS` - the CRS of additional coordinates needed for the operation, or `null` if none.
      `method` - the coordinate operation method (mandatory in all cases).
      `baseToDerived` - transform from positions in the base CRS to positions in this target CRS.
      `derivedCS` - the coordinate system for the derived CRS.
    Throws:
      `IllegalArgumentException` - if at least one argument has an incompatible number of dimensions.
    See Also:
      - `create(Map, SingleCRS, CoordinateReferenceSystem, OperationMethod, MathTransform, CoordinateSystem)`

  - ### DefaultDerivedCRS

    protected DefaultDerivedCRS(DerivedCRS crs)
    Constructs a new coordinate reference system with the same values as the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Parameters:
      `crs` - the coordinate reference system to copy.
    See Also:
      - `castOrCopy(DerivedCRS)`

- ## Method Details

  - ### create

    public static DefaultDerivedCRS create(Map<String,?> properties, SingleCRS baseCRS, Conversion baseToDerived, CoordinateSystem derivedCS) throws MismatchedDimensionException
    Creates a derived CRS from a defining conversion and a type inferred from the given arguments. This method expects the same arguments and performs the same work as the above constructor, except that the `DerivedCRS` instance returned by this method may additionally implement the `GeodeticCRS`, `VerticalCRS`, `TemporalCRS`, `ParametricCRS` or `EngineeringCRS` interface. See the class javadoc for more information.
    Parameters:
      `properties` - the properties to be given to the new derived CRS object.
      `baseCRS` - coordinate reference system to base the derived CRS on.
      `baseToDerived` - the defining conversion from a normalized base to a normalized derived CRS.
      `derivedCS` - the coordinate system for the derived CRS. The number of axes must match the target dimension of the `baseToDerived` transform.
    Returns:
      the newly created derived CRS, potentially implementing an additional CRS interface.
    Throws:
      `MismatchedDimensionException` - if the source and target dimensions of `baseToDerived` do not match the dimensions of `base` and `derivedCS` respectively.
    See Also:
      - `DefaultDerivedCRS(Map, SingleCRS, Conversion, CoordinateSystem)`
      - `GeodeticObjectFactory​.createDerivedCRS(Map, CoordinateReferenceSystem, Conversion, CoordinateSystem)`

  - ### create

    public static DefaultDerivedCRS create(Map<String,?> properties, SingleCRS baseCRS, CoordinateReferenceSystem interpolationCRS, OperationMethod method, MathTransform baseToDerived, CoordinateSystem derivedCS)
    Creates a derived CRS from a math transform and a type inferred from the given arguments. This method expects the same arguments and performs the same work as the above constructor, except that the `DerivedCRS` instance returned by this method may additionally implement the `GeodeticCRS`, `VerticalCRS`, `TemporalCRS`, `ParametricCRS` or `EngineeringCRS` interface. See the class javadoc for more information.
    Parameters:
      `properties` - the properties to be given to the `DefaultConversion` object (with keys prefixed by `"conversion."`) and to the new derived CRS object.
      `baseCRS` - coordinate reference system to base the derived CRS on.
      `interpolationCRS` - the CRS of additional coordinates needed for the operation, or `null` if none.
      `method` - the coordinate operation method (mandatory in all cases).
      `baseToDerived` - transform from positions in the base CRS to positions in this target CRS.
      `derivedCS` - the coordinate system for the derived CRS.
    Returns:
      the newly created derived CRS, potentially implementing an additional CRS interface.
    Throws:
      `IllegalArgumentException` - if at least one argument has an incompatible number of dimensions.
    See Also:
      - `DefaultDerivedCRS(Map, SingleCRS, CoordinateReferenceSystem, OperationMethod, MathTransform, CoordinateSystem)`

  - ### castOrCopy

    public static DefaultDerivedCRS castOrCopy(DerivedCRS object)
    Returns a SIS coordinate reference system implementation with the same values as the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getInterface

    public Class<? extends DerivedCRS> getInterface()
    Returns the GeoAPI interface implemented by this class. The SIS implementation returns `DerivedCRS​.class`.

    #### Note for implementers

    Subclasses usually do not need to override this method since GeoAPI does not define `DerivedCRS` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
    Overrides:
      `getInterface` in class `AbstractCRS`
    Returns:
      `DerivedCRS​.class` or a user-defined sub-interface.

  - ### getDatum

    public Datum getDatum()
    Returns the datum of the base CRS. This property may be null if this CRS is related to an object identified only by a datum ensemble.
    Specified by:
      `getDatum` in interface `SingleCRS`
    Returns:
      the datum of the base CRS, or `null` if this CRS is related to an object identified only by a datum ensemble.

  - ### getDatumEnsemble

    public DefaultDatumEnsemble<?> getDatumEnsemble()
    Returns the datum ensemble of the base CRS. This property may be null if this CRS is related to an object identified only by a reference frame.
    Returns:
      the datum ensemble of the base CRS, or `null` if this CRS is related to an object identified only by a datum.
    Since:
      1.5

  - ### getBaseCRS

    public SingleCRS getBaseCRS()
    Returns the CRS on which the conversion is applied. This CRS defines the datum of this CRS and (at least implicitly) the source of the conversion from base.
    Specified by:
      `getBaseCRS` in interface `GeneralDerivedCRS`
    Returns:
      the base coordinate reference system.

  - ### getConversionFromBase

    public Conversion getConversionFromBase()
    Returns the conversion from the base CRS to this CRS. In Apache SIS, the conversion source and target CRS are set to the following values:
    - The conversion source CRS is the base CRS of `this` CRS.
    - The conversion target CRS is `this` CRS.
    Note: This is different than ISO 19111, which allows source and target CRS to be `null`.
    Specified by:
      `getConversionFromBase` in interface `GeneralDerivedCRS`
    Returns:
      the conversion to this CRS.

  - ### getCoordinateSystem

    public CoordinateSystem getCoordinateSystem()
    Returns the coordinate system.
    Specified by:
      `getCoordinateSystem` in interface `CoordinateReferenceSystem`
    Specified by:
      `getCoordinateSystem` in interface `SingleCRS`
    Overrides:
      `getCoordinateSystem` in class `AbstractCRS`
    Returns:
      the coordinate system.

  - ### forConvention

    public DefaultDerivedCRS forConvention(AxesConvention convention)
    Returns a CRS equivalent to this one but with axes rearranged according the given convention. If this CRS is already compatible with the given convention, then this method returns `this`.
    Overrides:
      `forConvention` in class `AbstractCRS`
    Parameters:
      `convention` - the axes convention for which a coordinate reference system is desired.
    Returns:
      a coordinate reference system compatible with the given convention (may be `this`).
    See Also:
      - `AbstractCS​.forConvention(AxesConvention)`

  - ### equals

    public boolean equals(Object object, ComparisonMode mode)
    Compares this coordinate reference system with the specified object for equality. In addition to the metadata documented in the parent class, this method considers coordinate system axes of the base CRS as metadata. This means that if the given `ComparisonMode` is `IGNORE_METADATA` or more permissive, then axis order of the base CRS is ignored (but not axis order of this derived CRS).
    Specified by:
      `equals` in interface `LenientComparable`
    Overrides:
      `equals` in class `AbstractCRS`
    Parameters:
      `object` - the object to compare to `this`.
      `mode` - the strictness level of the comparison.
    Returns:
      `true` if both objects are equal.
    See Also:
      - `AbstractIdentifiedObject​.computeHashCode()`
      - `Utilities​.deepEquals(Object, Object, ComparisonMode)`

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats the inner part of the Well Known Text (WKT) representation of this CRS.
    Overrides:
      `formatTo` in class `AbstractCRS`
    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"Fitted_CS"` (WKT 1) or a type-dependent keyword (WKT 2).
    See Also:
      - `FormattableObject​.toWKT()`
      - `FormattableObject​.toString()`